"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
var category_1 = require("vigor-category/lib/libs/category");
module.exports = {
    urls: [
        "/thread/edit/:id"
    ],
    routers: {
        get: function (req, res, scope) { return __awaiter(_this, void 0, void 0, function () {
            var Thread, extracted, Category, user, found, categoryId, category, id, categories;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Thread = scope.models.Thread;
                        extracted = req.extracted.params;
                        Category = scope.models.Category;
                        user = req.session.user;
                        found = req.temporary.thread;
                        categoryId = 0;
                        category = null;
                        if (!found.category) return [3, 2];
                        id = found.category.id;
                        return [4, Category.findOne({ id: id })];
                    case 1:
                        category = _a.sent();
                        categoryId = category.id;
                        _a.label = 2;
                    case 2: return [4, category_1.getChild(scope.models, categoryId, user.id)];
                    case 3:
                        categories = _a.sent();
                        res.showPage("thread/edit", {
                            action: "edit",
                            thread: req.temporary.thread,
                            category: category,
                            categories: categories
                        });
                        return [2];
                }
            });
        }); },
        post: function (req, res, scope) { return __awaiter(_this, void 0, void 0, function () {
            var config, Thread, _a, params, body, user, found, regex, exec, cover, updates, url;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        config = scope.configs;
                        Thread = scope.models.Thread;
                        _a = req.extracted, params = _a.params, body = _a.body;
                        user = req.session.user;
                        found = req.temporary.thread;
                        regex = /(!\[.*?\]\((.*?)\)).*?/;
                        exec = regex.exec(body.content);
                        cover = "";
                        if (exec) {
                            cover = exec[2].split(" ")[0];
                        }
                        updates = {
                            title: body.title,
                            content: body.content,
                            loginRequired: body.loginRequired === "on",
                            updatedAt: new Date(),
                            cover: cover
                        };
                        if (body.category) {
                            updates.category = body.category;
                        }
                        return [4, Thread.update({
                                id: found.id
                            }, updates)];
                    case 1:
                        _b.sent();
                        url = req.originalUrl.replace("edit", "visit");
                        res.redirect(url);
                        return [2];
                }
            });
        }); }
    },
    policies: {
        get: "isThreadAuthor",
        post: "isThreadAuthor"
    },
    validations: {
        get: {
            params: {
                id: {
                    type: "string",
                    required: true
                }
            }
        },
        post: {
            params: {
                id: {
                    type: "string",
                    required: true
                }
            },
            body: {
                title: {
                    type: "string",
                    required: true
                },
                content: {
                    type: "text",
                    required: true
                },
                category: {
                    type: "int",
                },
                loginRequired: {
                    type: "string"
                }
            }
        }
    },
    failures: {
        policy: "notLogin",
        validation: "wrongInput"
    }
};
