"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
var paginator = require("waterline-paginator");
function favoriteIt(models, errors, thread, user) {
    return __awaiter(this, void 0, void 0, function () {
        var User, Thread, Favorite, favorite, created;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    User = models.User, Thread = models.Thread, Favorite = models.Favorite;
                    return [4, Favorite.findOne({
                            owner: user.id,
                            thread: thread.id
                        })];
                case 1:
                    favorite = _a.sent();
                    if (favorite) {
                        return [2, errors.FavoriteExists];
                    }
                    return [4, Favorite.create({
                            owner: user.id,
                            thread: thread.id
                        })];
                case 2:
                    created = _a.sent();
                    user.favoriteThreads++;
                    thread.favorites++;
                    return [4, User.update({
                            id: user.id
                        }, {
                            favoriteThreads: user.favoriteThreads
                        })];
                case 3:
                    _a.sent();
                    return [4, Thread.update({
                            id: thread.id
                        }, {
                            favorites: thread.favorites
                        })];
                case 4:
                    _a.sent();
                    return [2, errors.Success];
            }
        });
    });
}
;
module.exports = {
    urls: [
        "/thread/favorite/:id"
    ],
    pagers: {
        all: true
    },
    routers: {
        get: function (req, res, scope) { return __awaiter(_this, void 0, void 0, function () {
            var _a, User, Thread, params, query, user, options, found, result, ids, data, sql, threads;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = scope.models, User = _a.User, Thread = _a.Thread;
                        params = scope.extracted.params;
                        query = scope.query;
                        options = {
                            or: [
                                {
                                    username: params.id
                                }, {
                                    id: params.id
                                }
                            ]
                        };
                        return [4, User.findOne(options)];
                    case 1:
                        found = _b.sent();
                        if (!found) {
                            return [2, res.showPage("notify/notify", {
                                    error: "这个用户不存在。"
                                })];
                        }
                        user = found;
                        return [4, paginator.page({
                                conditions: {
                                    owner: found.id
                                },
                                model: scope.models.Favorite,
                                limit: query.limit,
                                page: query.page
                            })];
                    case 2:
                        result = _b.sent();
                        ids = [];
                        data = result.results;
                        data.forEach(function (item) {
                            ids.push(item.thread);
                        });
                        sql = {
                            id: ids,
                            sort: "createdAt asc"
                        };
                        return [4, Thread.find(sql)
                                .populate("author")
                                .populate("lastReplier")];
                    case 3:
                        threads = _b.sent();
                        res.showPage("thread/favorite", {
                            user: user,
                            threads: threads,
                            total: result.total,
                            page: result.page,
                            count: result.count
                        });
                        return [2];
                }
            });
        }); },
        post: function (req, res, scope) { return __awaiter(_this, void 0, void 0, function () {
            var user, id, Thread, thread, error;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        user = req.session.user;
                        id = req.params.id;
                        Thread = scope.models.Thread;
                        return [4, Thread.findOne({
                                id: id
                            }).populate("author")];
                    case 1:
                        thread = _a.sent();
                        if (!thread) {
                            return [2, res.showPage("notify/notify", {
                                    error: "主题不存在或者已经被删除!"
                                })];
                        }
                        return [4, favoriteIt(scope.models, scope.errors, thread, user)];
                    case 2:
                        error = _a.sent();
                        switch (error.name) {
                            case "FavoriteExists":
                                return [2, res.showPage("notify/notify", {
                                        refresh: "/thread/visit/" + thread.id,
                                        error: "主题已经收藏过，不再重复收藏!"
                                    })];
                            case "Success":
                            default:
                                return [2, res.showPage("notify/notify", {
                                        refresh: "/thread/visit/" + thread.id,
                                        error: "收藏成功!"
                                    })];
                        }
                        return [2];
                }
            });
        }); }
    },
    policies: {
        post: "isLogin"
    },
    validations: {
        get: {
            query: {
                limit: {
                    type: "string"
                },
                page: {
                    type: "string"
                }
            },
            params: {
                id: {
                    type: "string",
                    required: true
                }
            }
        }
    },
    failures: {
        policy: "notLogin",
        validation: "wrongInput"
    }
};
