"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var category_1 = require("vigor-category/lib/libs/category");
module.exports = {
    urls: [
        "/thread/visit/:id"
    ],
    routers: {
        get: function (req, res, scope) { return __awaiter(_this, void 0, void 0, function () {
            var _a, Thread, Post, RedEnvelopeThread, Category, extracted, user, thread, category, categoryId, categories, created, unanswered, posts, redenvelopes;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = scope.models, Thread = _a.Thread, Post = _a.Post, RedEnvelopeThread = _a.RedEnvelopeThread, Category = _a.Category;
                        extracted = req.extracted.params;
                        user = req.session.user;
                        return [4, Thread.findOne({
                                id: extracted.id
                            }).populate("author").populate("category")];
                    case 1:
                        thread = _b.sent();
                        category = null;
                        categoryId = 0;
                        if (thread) {
                            category = thread.category;
                        }
                        if (category && category.id) {
                            categoryId = category.id;
                        }
                        categories = null;
                        if (!(user && user.id)) return [3, 3];
                        return [4, category_1.getChild(scope.models, categoryId, user.id)];
                    case 2:
                        categories = _b.sent();
                        return [3, 5];
                    case 3: return [4, category_1.getChild(scope.models, categoryId)];
                    case 4:
                        categories = _b.sent();
                        _b.label = 5;
                    case 5:
                        if (!thread) {
                            return [2, res.vRender({
                                    error: "此话题不存在或已被删除。"
                                }, "notify/notify")];
                        }
                        thread.visits++;
                        return [4, Thread.find({
                                author: thread.author.id
                            }).sort("createdAt desc").limit(5)];
                    case 6:
                        created = _b.sent();
                        return [4, Thread.find({
                                deleted: false,
                                locked: false,
                                lastReplier: null
                            }).sort({
                                createdAt: "desc"
                            }).limit(5)];
                    case 7:
                        unanswered = _b.sent();
                        return [4, Post.find({
                                thread: thread.id
                            }).populate("author")];
                    case 8:
                        posts = _b.sent();
                        return [4, Thread.update({
                                id: thread.id
                            }, {
                                visits: thread.visits
                            })];
                    case 9:
                        _b.sent();
                        return [4, RedEnvelopeThread.find({
                                thread: thread.id
                            }).populate("user")];
                    case 10:
                        redenvelopes = _b.sent();
                        thread.posts = posts;
                        thread.redenvelopes = redenvelopes;
                        res.showPage("thread/visit", {
                            thread: thread,
                            categories: categories,
                            category: category,
                            others: created,
                            unanswered: unanswered
                        }, true);
                        return [2];
                }
            });
        }); }
    },
    validations: {
        get: {
            params: {
                id: {
                    type: "string",
                    required: true
                }
            }
        }
    }
};
