var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
function like(models, errors, thread, user) {
    return __awaiter(this, void 0, void 0, function () {
        var Thread, ThreadLike, criteria, tl, numbers;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    Thread = models.Thread, ThreadLike = models.ThreadLike;
                    criteria = {
                        user: user.id,
                        thread: thread.id
                    };
                    return [4, ThreadLike.findOne(criteria)];
                case 1:
                    tl = _a.sent();
                    if (!tl) return [3, 5];
                    return [4, ThreadLike.destroy(criteria)];
                case 2:
                    _a.sent();
                    return [4, ThreadLike.count({
                            thread: thread.id
                        })];
                case 3:
                    numbers = _a.sent();
                    return [4, Thread.update({
                            id: thread.id
                        }, {
                            likes: numbers
                        })];
                case 4:
                    _a.sent();
                    return [2, errors.LikeExists];
                case 5: return [4, ThreadLike.create({
                        user: user.id,
                        thread: thread.id
                    })];
                case 6:
                    _a.sent();
                    thread.likes++;
                    return [4, Thread.update({
                            id: thread.id
                        }, {
                            likes: thread.likes
                        })];
                case 7:
                    _a.sent();
                    return [2, errors.Success];
            }
        });
    });
}
function dislike(models, errors, thread, user) {
    return __awaiter(this, void 0, void 0, function () {
        var Thread, ThreadDislike, td, numbers;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    Thread = models.Thread, ThreadDislike = models.ThreadDislike;
                    return [4, ThreadDislike.findOne({
                            user: user.id,
                            thread: thread.id
                        })];
                case 1:
                    td = _a.sent();
                    if (!td) return [3, 5];
                    return [4, ThreadDislike.destroy(td.id)];
                case 2:
                    _a.sent();
                    return [4, ThreadDislike.count({
                            thread: thread.id
                        })];
                case 3:
                    numbers = _a.sent();
                    return [4, Thread.update({
                            id: thread.id
                        }, {
                            dislikes: numbers
                        })];
                case 4:
                    _a.sent();
                    return [2, errors.DislikeExists];
                case 5: return [4, ThreadDislike.create({
                        user: user.id,
                        thread: thread.id
                    })];
                case 6:
                    _a.sent();
                    thread.dislikes++;
                    return [4, Thread.update({
                            id: thread.id
                        }, {
                            dislikes: thread.dislikes
                        })];
                case 7:
                    _a.sent();
                    return [2, errors.Success];
            }
        });
    });
}
function choose(req, res, scope, thread, action) {
    return __awaiter(this, void 0, void 0, function () {
        var user, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    user = req.session.user;
                    _a = action;
                    switch (_a) {
                        case "dislike": return [3, 1];
                        case "like": return [3, 3];
                    }
                    return [3, 3];
                case 1: return [4, dislike(scope.models, scope.errors, thread, user)];
                case 2: return [2, _b.sent()];
                case 3: return [4, like(scope.models, scope.errors, thread, user)];
                case 4: return [2, _b.sent()];
            }
        });
    });
}
function act(req, res, scope, action) {
    return __awaiter(this, void 0, void 0, function () {
        var id, Thread, thread, error;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    id = req.params.id;
                    Thread = scope.models.Thread;
                    return [4, Thread.findOne({
                            id: id
                        }).populate("author")];
                case 1:
                    thread = _a.sent();
                    if (!thread) {
                        return [2, res.vRender({
                                error: "主题不存在或者已经被删除!"
                            }, "notify/notify")];
                    }
                    return [4, choose(req, res, scope, thread, action)];
                case 2:
                    error = _a.sent();
                    switch (action) {
                        case "like":
                            switch (error.name) {
                                case "LikeExists":
                                    return [2, res.vRender({
                                            refresh: "/thread/visit/" + thread.id,
                                            error: "取消喜欢!"
                                        }, "notify/notify")];
                                case "Success":
                                default:
                                    scope.event.send("message-thread-like", req.session.user, thread.author, thread);
                                    return [2, res.vRender({
                                            refresh: "/thread/visit/" + thread.id,
                                            error: "喜欢成功!"
                                        }, "notify/notify")];
                            }
                        case "dislike":
                        default:
                            switch (error.name) {
                                case "DislikeExists":
                                    return [2, res.vRender({
                                            refresh: "/thread/visit/" + thread.id,
                                            error: "取消不喜欢!"
                                        }, "notify/notify")];
                                case "Success":
                                default:
                                    return [2, res.vRender({
                                            refresh: "/thread/visit/" + thread.id,
                                            error: "不喜欢成功!"
                                        }, "notify/notify")];
                            }
                    }
                    return [2];
            }
        });
    });
}
module.exports = {
    like: function (req, res, scope) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, act(req, res, scope, "like")];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    }); },
    dislike: function (req, res, scope) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, act(req, res, scope, "dislike")];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    }); }
};
